import whyIsNodeRunning from 'why-is-node-running';
import { request } from 'undici';

console.log(`started with pid: ${process.pid}`)

async function makeRequest(idx = 1) {
    const result = await request(`https://example.com/`)
        .then(({ body }) => body.json())
        .catch(() => 'oops')

    console.log(new Date().toString(), `completed request #${idx} of 5`);
    global.gc();

    if (idx === 5) {
        setTimeout(() => {
            global.gc();
            let undiciRequests = 0;
            whyIsNodeRunning({
                error(msg) {
                    if (msg?.startsWith('# UNDICI_REQUEST')) {
                        undiciRequests += 1;
                    }
                    console.error(msg);
                }
            });
            console.error(`Total undici requests: ${undiciRequests}`);
        }, 1_000);
    } else {
        setTimeout(makeRequest, 500, idx + 1);
    }
}

makeRequest();